#ifndef _STEP_COUNTER_H_
#define _STEP_COUNTER_H_

#include "Nano100Series.h"
#include <stdio.h>
#include <string.h>
#include "lx_data_manager.h"
#include "health-algorithm.h"
#include "click-algorithm.h"


#define  STEPDEBUG

#define SPORTS_DATA_MOCK_TEST
#define SPORTS_DATA_MOCK_TEST

#define UNUSED_VARIABLE(X)  ((void)(X))
#define UNUSED_PARAMETER(X) UNUSED_VARIABLE(X)

typedef struct
{
uint16_t day   :
    5;
uint16_t month  :
    4;
uint16_t year   :
    6;
uint16_t reserved   :
    1;
}
Date_bit_field_type_t;
typedef union
{
    uint16_t data;
    Date_bit_field_type_t date;
} Date_union_t;

typedef struct SportsHead
{
    uint8_t key;
    uint8_t length;
    Date_union_t Date;
}
SportsHead_t;

typedef struct SleepHead
{
    Date_union_t Date;
    uint16_t length;
}
SleepHead_t;

typedef struct
{
uint64_t Distance  :
    16;
uint64_t Calory   :
    19;
uint64_t active_time :
    4;
uint64_t steps   :
    12;
uint64_t mode   :
    2;
uint64_t offset   :
    11;
}
SportsData_bit_field_type_t;

typedef union SportsData {
    uint64_t data;
    SportsData_bit_field_type_t bits;
} SportsData_U;

typedef struct
{
uint32_t mode   :
    4;
uint32_t sleeping_flag :
    1;
uint32_t reserved  :
    11;
uint32_t timeStamp  :
    16;
}
SleepData_bit_field_type_t;

typedef union SleepDataU {
    uint32_t data;
    SleepData_bit_field_type_t bits;
} SleepData_U;



void health_algorithm_cb_implement(algorithm_event_t *event, void* user_data);
uint8_t start_health_algorithm(userprofile_union_t *user_profile);
void update_algorithm_timestamp(void);
void handle_sleep_event(algorithm_event_t *event);
void handle_distance_event(algorithm_event_t *event);
void sleep_evt_handler(algorithm_event_t *event);
uint8_t sports_mode(void);
void sensor_timer_handle(void);
void click_algorithm_cb_implement(click_event_t *event, void* user_data);
void start_click_algorithm(void );

#endif

