#ifndef WALL_CLOCK_TIMER_H_
#define WALL_CLOCK_TIMER_H_

#include "lx_communicate_protocol.h"
#include "Nano100Series.h"
#include "stdint.h"
typedef uint32_t UTCTime; /* used to store the second counts for RTC */

#define DAY             86400UL  // 24 hours * 60 minutes * 60 seconds
#define IsLeapYear(yr) (!((yr) % 400) || (((yr) % 100) && !((yr) % 4)))

#define YearLength(yr) (IsLeapYear(yr) ? 366 : 365)

typedef struct
{
    uint16_t year;    // 2000+
    uint8_t month;    // 0-11
    uint8_t day;      // 0-30
    uint8_t seconds;  // 0-59
    uint8_t minutes;  // 0-59
    uint8_t hour;     // 0-23
}
UTCTimeStruct;

void system_clock_init(void);
void set_system_clock(time_union_t time);
UTCTime get_wall_clock_time_counter(void);
UTCTime convert_time_to_Second(time_union_t time);
void Init_RTC(void);
#endif

