#include <stdio.h>
#include <stdint.h>
#include  <math.h> 
#include "Nano100Series.h"
#include "I2Cdev.h"
#include "GY_282.h"
#include "lx_data_manager.h"

static double angle_data;

void GY282_WriteByte(uint8_t GY282_reg, uint8_t GY282_data)
{
	uint8_t data[1];
	   data[0]=GY282_data;
     I2C_writeBytes(GY282_I2C_PORT, GY282_I2C_SLA, GY282_reg, 1, data);
}

uint8_t GY282_ReadByte(uint8_t GY282_reg)
{
	uint8_t data[1];
     I2C_readBytes(GY282_I2C_PORT, GY282_I2C_SLA, GY282_reg, 1, data);	
	   return (data[0]);
}

void GY282_Init()
{
  GY282_WriteByte(0x02,0x00);
	GY282_WriteByte(0x01,0xE0);
}

int16_t Read_GY282_DataX(void)
{
	uint8_t LoByte, HiByte;
	LoByte = GY282_ReadByte(0x04); // read Accelerometer X_Low  value
	HiByte = GY282_ReadByte(0x03); // read Accelerometer X_High value
	return((HiByte<<8) | LoByte);
}

int16_t Read_GY282_DataY(void)
{
	uint8_t LoByte, HiByte;
	LoByte = GY282_ReadByte(0x08); // read Accelerometer X_Low  value
	HiByte = GY282_ReadByte(0x07); // read Accelerometer X_High value
	return ((HiByte<<8) | LoByte);
}
int16_t Read_GY282_DataZ(void)
{
	uint8_t LoByte, HiByte;
	LoByte = GY282_ReadByte(0x06); // read Accelerometer X_Low  value
	HiByte = GY282_ReadByte(0x05); // read Accelerometer X_High value
	return ((HiByte<<8) | LoByte);
}

void GY282_Data_handle(void)
{
	int16_t x,y,z;
	int i,n=0;
	unsigned int angle[10];
	double angle_num=0;
	for(i=0;i<10;i++)
	{
		x = Read_GY282_DataX(); 
    y = Read_GY282_DataY(); 
	  z = Read_GY282_DataZ(); 
		angle[i]=atan2((double)x,(double)y) * (180 / 3.14159265) + 180;
		if(angle[i]!=44&&i==0)
		{
			angle_num+=angle[i];
			printf("%d\r\n",angle[i]);
			n++;
		}
		if(angle[i]!=44&&i>0)
		{
			if((angle[i]-angle[i-1]<3)||(angle[i-1]-angle[i]<3))
				{
			    printf("%d\r\n",angle[i]);
					n++;
		      angle_num+=angle[i];
				}
		}
	}
	angle_num=angle_num/n;
	if(angle_num==0)
	    return ;
	angle_data=angle_num;
	n=0;
	angle_num=0;
	printf("%F\r\n",angle_data);
//	*angle=angle_data;
}

double Get_GY282_Data(void)
{
	  return angle_data;
}

