#include "lx_blu_communication.h"
#include "lx_data_manager.h"
#include "lx_step_counter.h"
#include "lx_lcd_show.h"
#include "I2C_SSD1306Z.h"
#include "lx_wifi.h"

volatile int Is_handle=0,Have_data=0;

volatile S_RTC_TIME_DATA_T Rev_Time;

char RX_buffer[20];


volatile uint8_t col=0;

userprofile_union_t myuser;
uint32_t  u32Count=0;
void Init_UART0(void)
{
    UART_Open(UART0, 115200);	// enable UART0 at 115200 baudrate
    UART_ENABLE_INT(UART0, UART_IER_RDA_IE_Msk);
    NVIC_EnableIRQ(UART0_IRQn);
//    UART0->CTL|=(0x01<<4);	
}
void UART0_IRQHandler(void)
{ 
	 char inchar;
	  uint32_t u32IntSts= UART0->ISR; 
	 if(u32IntSts & UART_IS_RX_READY(UART0)) {	
		inchar=UART_READ(UART0);
		RX_buffer[col++]=inchar;
	 }
	 if(UART0->FSR & UART_FSR_RX_EMPTY_F_Msk) {		 /* Check RX empty => failed */
	 CLK_SysTickDelay(200000);
	 if(UART0->FSR & UART_FSR_RX_EMPTY_F_Msk) {
   RX_buffer[col]='\0';
	 col=0;
	 printf("%s\r\n",RX_buffer);
	 printf("RX_0:%c RX_1:%c\r\n",RX_buffer[0],RX_buffer[1]);
	 Is_handle=1;
	 Receive_Data_Handle();
	 }
	 }
}
void Send_Data_To_Phone()
{
	char data[30];
	blu_data blu_send;
	blu_send.calories=get_global_calories_counts_today();
	blu_send.heart_rute=get_curt_heart_date();
	get_global_curt_HTU21D(&blu_send.temp,&blu_send.humidy);
	blu_send.step=get_global_step_counts_today();
	blu_send.if_danger=0;
	sprintf(data,"%4d%4d%3d",blu_send.step,blu_send.calories,blu_send.heart_rute);
  UART_Write(UART0,(uint8_t *)data,strlen(data));	
}

void Get_SSID_PASSWAR()
{
	int i;
	char RX_SSID[16];
  char RX_Passward[16];
	if(RX_buffer[1]=='0')
	{
			printf("GET SSID\r\n");
	    for(i=2;i<14;i++)
	    {
		      if(RX_buffer[i]!='#')
		      {
			        RX_SSID[i-2]=RX_buffer[i];
		      }
		      else 
		      {
			        break;
		      }
	     }
			 RX_SSID[i]='\0';
       printf("SSID:%s\r\n",RX_SSID);
			 Set_SSID(RX_SSID);
			 for(i=0;i<16;i++)
			     RX_SSID[i]=0;
  }
	if(RX_buffer[1]=='1')
	{
	    for(i=2;i<14;i++)
	    {
		     if(RX_buffer[i]!='#')
		     {
			      RX_Passward[i-2]=RX_buffer[i];
		     }
		     else 
		     {			      
			      break;
	   	   }
	    }
			RX_Passward[i]='\0';
	    printf("RX_Passward:%s\r\n",RX_Passward);
			Set_passward(RX_Passward);
			for(i=0;i<16;i++)
			     RX_Passward[i]=0;
   }
 }

void Receive_Data_Handle()
{
	 int i;
	 if(Is_handle==1)
	 {
		 if(RX_buffer[0]=='2')
		 {		 
			  printf("respond Send_Data_To_Phone");
        Send_Data_To_Phone();	
			  CLK_SysTickDelay(20000); 			 
        Rev_Time.u32Year=2016;
			  Rev_Time.u32Month=(RX_buffer[1]-'0')*10+(RX_buffer[2]-'0');
			  Rev_Time.u32Day=(RX_buffer[3]-'0')*10+(RX_buffer[4]-'0');
			  Rev_Time.u32Hour=(RX_buffer[5]-'0')*10+(RX_buffer[6]-'0');
			  Rev_Time.u32Minute=(RX_buffer[7]-'0')*10+(RX_buffer[8]-'0');
			  RTC_SetDateAndTime(&Rev_Time);
			  clear_LCD();
	      Lcd_Show(); 
		 }
		 if(RX_buffer[0]=='0')
		     Get_SSID_PASSWAR();
     if(RX_buffer[0]=='1')
		 {
			 myuser.bit_field.age=(RX_buffer[1]-'0')*10+(RX_buffer[2]-'0');
			 printf("age:%d\r\n",myuser.bit_field.age);
			 myuser.bit_field.hight=(RX_buffer[3]-'0')*100+(RX_buffer[4]-'0')*10+(RX_buffer[5]-'0');
			 printf("hight:%d\r\n",myuser.bit_field.hight);
			 myuser.bit_field.weight=(RX_buffer[6]-'0')*10+(RX_buffer[7]-'0');
			 printf("weight:%d\r\n",myuser.bit_field.weight);
			 myuser.bit_field.gender=(RX_buffer[8]-'0');
			 printf("gender:%d\r\n",myuser.bit_field.gender);
			 printf("OK");
			 start_health_algorithm(&myuser);
	     start_click_algorithm();
			 TIMER_Stop(TIMER0);
       clear_LCD();		
       print_Line(1,"UPDATA:OK");	
			 for(i=0;i<5;i++)
          CLK_SysTickDelay(1000);
       clear_LCD();			 
       TIMER_Start(TIMER0);			 
		 }	
     Is_handle=0; 
		 for(i=0;i<20;i++)
		 {
			 RX_buffer[i]=0;
		 }		 
	 }
}
