#include "lx_step_counter.h"
#include "lx_data_manager.h"
#include "click-algorithm.h"
#include "health-algorithm.h"
#include "lx_wall_clock_timer.h"
#include "MPU6500.h"
#include "lx_square_root.h"

static uint8_t mSleep_mode = NONE_SLEEP;

int static daily_target_achieved = 0;

static algorithm_event_sleep_t current_sleep_event;

SportsData_U mSportsData;
SportsHead_t mSportHead;
SleepData_U  mSleepData;
SleepHead_t  mSleepHead;



static uint16_t walkingSlow = 0,walkingQuick = 0,running = 0,maxMode = 0;
int static  algorithm_started = 0;//㷨Ƿ

static long long algorithm_timestamp = 0;

void stop_health_algorithm(void)
{
     algorithm_started = 0;
     health_algorithm_finalize();
}

uint8_t sports_mode(void)
{
    uint8_t sportMode;

    maxMode = walkingSlow > walkingQuick?walkingSlow:walkingQuick;//STEP_MODE_WALK_SLOW;
    maxMode = maxMode > running?maxMode:running;

    if(maxMode == walkingSlow) {
        sportMode = STEP_MODE_WALK_SLOW;
    } else if(maxMode == walkingQuick) {
        sportMode = STEP_MODE_WALK_QUICK;
    } else {
        sportMode = STEP_MODE_RUN;
    }
    return sportMode;
}

void handle_distance_event(algorithm_event_t *event)
{
    uint8_t sportMode;
    if(event->distance.new_steps > 0) {

        set_global_step_counts_today(get_global_step_counts_today() + event->distance.new_steps);//½ղ
        set_global_calories_counts_today(get_global_calories_counts_today() + event->distance.new_calory);//½տ·
    }
}
void sleep_evt_handler(algorithm_event_t *event)
{
    int sleepHead_minutes;
    int sleep_minutes = event->sleep.starting_time_stamp/60;
    time_union_t sleep_head_time;
    sleep_head_time.data = 0;
    sleep_head_time.time.year = mSleepHead.Date.date.year;
    sleep_head_time.time.month= mSleepHead.Date.date.month;
    sleep_head_time.time.day= mSleepHead.Date.date.day;

//    sleepHead_minutes = convert_time_to_Second(sleep_head_time)/60;

    mSleepData.bits.timeStamp = (uint16_t)(sleep_minutes - sleepHead_minutes);

    current_sleep_event.mode = event->sleep.mode;
    current_sleep_event.starting_time_stamp = event->sleep.starting_time_stamp;
    mSleepData.bits.mode= event->sleep.mode;
    mSleepHead.length ++;

//    g_sleep_send_buffer[SPORT_HEAD_LEN + ((mSleepHead.length-1) <<2) + 0] = mSleepData.data >> 24; //OFFSET
//    g_sleep_send_buffer[SPORT_HEAD_LEN + ((mSleepHead.length-1) <<2) + 1] = mSleepData.data >> 16; // reserved
//    g_sleep_send_buffer[SPORT_HEAD_LEN + ((mSleepHead.length-1) <<2) + 2] = mSleepData.data >> 8; // reserved
//    g_sleep_send_buffer[SPORT_HEAD_LEN + ((mSleepHead.length-1) <<2) + 3] = mSleepData.data;


//    if(mSleepHead.length >= SLEEP_MAX_GROUP_NUM) {
//        save_sleep_group_data((uint8_t)mSleepHead.length);
//    }

}
void handle_sleep_event(algorithm_event_t *event)
{
    
    mSleep_mode = event->sleep.mode;


    sleep_evt_handler(event);
    
 //  send_all_data(false);

}

void health_algorithm_cb_implement(algorithm_event_t *event, void* user_data)
{
    uint8_t j = 0;

    time_union_t sport_head_time;
	  algorithm_event_t sport_event;
	  uint32_t sport_head_seconds;
#ifdef SPORTS_DATA_MOCK_TEST
    static int inner_step_count = 1;
    static UTCTime init_time =0;
//    if(init_time == 0) {
//        init_time = get_wall_clock_time_counter(); //ȡǰʱ
//    }
//    init_time = (((init_time - 1) / 60) + 1) * 60;    //round up to 60
//    sport_head_time.data = 0;
//    sport_head_time.time.year = mSportHead.Date.date.year;
//    sport_head_time.time.month = mSportHead.Date.date.month;
//    sport_head_time.time.day = mSportHead.Date.date.day;
//    sport_head_seconds = convert_time_to_Second(sport_head_time);

       sport_event.event_common.type = DISTANCE_EVENT;
       sport_event.distance.new_steps = 1;
       sport_event.distance.new_distances = 0.5;
       sport_event.distance.new_calory = 0.1;
       sport_event.distance.mode = (step_mode_t) (j%3);       
       handle_distance_event(&sport_event); 


#else    

    UNUSED_VARIABLE(user_data);
    if(event->event_common.type == DISTANCE_EVENT) {
        handle_distance_event(event);
    }

#endif
#ifdef SLEEP_DATA_MOCK_TEST    
    static int count = 0; 
    uint8_t i;

    time_union_t sleep_head_time;
    
    sleep_head_time.data = 0;
    sleep_head_time.time.year = mSleepHead.Date.date.year;
    sleep_head_time.time.month= mSleepHead.Date.date.month;
    sleep_head_time.time.day= mSleepHead.Date.date.day;

//    uint32_t sleepHead_seconds = convert_time_to_Second(sleep_head_time);

    algorithm_event_t sleep_event;
    for(i=0; (i<10) && (count < 30000) ; i++,count++) {
        sleep_event.event_common.type = SLEEP_EVENT;
        if(i%2 == 0) {
            sleep_event.sleep.mode = DEEP_SLEEP;
        } else { 
            sleep_event.sleep.mode = NONE_SLEEP;
        }

        sleep_event.sleep.starting_time_stamp = sleepHead_seconds + 60*i;
        handle_sleep_event(&sleep_event);
    }
#else 

    if(event->event_common.type == SLEEP_EVENT) {   //      SLEEP_EVENT
        handle_sleep_event(event);
    }


#endif

}

uint8_t start_health_algorithm(userprofile_union_t *user_profile)//ʼ㷨
{
    int err_code= 0;
    int hight_cm = user_profile->bit_field.hight;
    int weight_kg = user_profile->bit_field.weight;
    int age = user_profile->bit_field.age;
    char isfemale = user_profile->bit_field.gender;

    if(algorithm_started == 1) {
        stop_health_algorithm();
    }

    err_code = init_health_algorithm(25,hight_cm,weight_kg,age,isfemale);//ʼ㷨 ص
    if(err_code==0)
		{ 
			 algorithm_started = 1;
#ifdef  STEPDEBUG
				 printf("init_health_algorithm  OK\r\n");
#endif		    
       update_algorithm_timestamp();//
       err_code = register_health_algorithm_callback(health_algorithm_cb_implement,(void *)NULL);//㷨עص
       if(err_code==0)
			 {
#ifdef  STEPDEBUG
				 printf("register_health_algorithm_callback  OK\r\n");
#endif		 
				 Init_MPU6500();
			 }
       return 0;
		}
}


void update_algorithm_timestamp(void)
{
    algorithm_timestamp = get_wall_clock_time_counter();
    algorithm_timestamp *= 1000;
//    LOG(LEVEL_INFO, "ts: %lld : RTC: %d", algorithm_timestamp, get_wall_clock_time_counter());

}
static long long click_algorithm_timestamp = 0;
void sensor_timer_handle()
{
    int error_no = 0;

    uint8_t transfer_size;
    uint16_t compose;
    uint16_t accX,accY,accZ;
    uint8_t acc_ii = 0;
    
//    hal_acc_GetFifoData(&transfer_size);
        
     accX = (Read_MPU6500_AccX()>>3);  // mg
     accY = (Read_MPU6500_AccY()>>3);
     accZ = (Read_MPU6500_AccZ()>>3);
#ifdef  STEPDEBUG
//     printf("X:%d ",accX);
//	   printf("Y:%d ",accY);
//	   printf("Z:%d\r\n ",accZ);
#endif
     compose = SquareRoot(accX*accX + accY*accY + accZ*accZ);
     algorithm_timestamp += 39;
     error_no = health_algorithm_data_in_accelerate(accX,accY,accZ,compose,algorithm_timestamp);
}
void click_algorithm_cb_implement(click_event_t *event, void* user_data)
{

//    LOG(LEVEL_INFO,"click_algorithm_cb_implement \n");

//    Taped_cnt ++;

//    if(Taped_cnt == 1) {
//        first_tap_detected = true;
//        app_timer_start(m_double_tap_timer_id, TAP_INTERVAL_1, NULL);
//    }

}


void start_click_algorithm(void )
{

    int err_code= 0;

    init_click_algorithm(100);

    err_code = register_click_algorithm_callback(click_algorithm_cb_implement,(void *)NULL);

}

